#<xmp>
<jsp:useBean id="admin" class="com.ibm.servlet.config.WasWebAdmin" scope="session"/>
<jsp:directive.page language="java" />
<jsp:directive.page import="java.util.*" />
<jsp:directive.page import="org.w3c.dom.*" />
<%
boolean initProblems = false;
String  initResult = null;
if (!admin.initInProgress())
{
   System.out.println("webadmin.jsp No init in progress at this time, ask for one to start.");
   initResult = admin.startInitialize();
   System.out.println("webadmin.jsp request processed for init to start. initResult="+initResult);
}
else
{
   System.out.println("webadmin.jsp Init in progress at this time, ask for status.");
   initResult = admin.checkInitInProgress();
   System.out.println("webadmin.jsp request processed for status of init. initResult="+initResult);
}

if (!admin.initInProgress())
{
  System.out.println("webadmin.jsp No init in progress at this time, construct app map.");
  String sessionID = "none";
  Object mySession = null;
  String mySessionID = "null";
  try {
    if (session.getId() != null) {
      sessionID = session.getId().getClass().getName();
    }
  } catch (Throwable tu) {
    sessionID = "Exceptional";
  }
  if (initResult != null) {
    initProblems = true;
  }
  String adminID = admin.getClass().getName()+":"+Integer.toString(admin.hashCode());
  String productEditionName = com.ibm.servlet.util.WASSystem.getProductEdition(); 
  String productBuild = com.ibm.servlet.util.WASSystem.getProductBuild();
  com.ibm.ejs.sm.client.ui.NLS myNLS = new com.ibm.ejs.sm.client.ui.NLS("webadmin");
  String editionTitle = myNLS.getString("webadmin.edition.title","edition");
  String productName = myNLS.getString("menuBar.console.aboutDescription","IBM Websphere Systems Management");  
  String nodeName = myNLS.getString("webadmin.nodeName.unknown","Unknown");
  try {
    nodeName = admin.getCurrentNode();
  } catch (Throwable t) {
    initResult = initResult + "\n /*unable to get current node"+t.toString()+"*/";
  }
 
  if (initProblems) 
  {
    System.out.println("webadmin.jsp init complete.  Results were: " + initResult); 
  }
%>
#AdminID=<%=adminID%>
#SessionID=<%=sessionID%>
#mySessionID=<%=mySessionID%>
TaskDefault.subtitle=<%=nodeName %>
WASAdmin.DrawerLabel=<%=productName %>
#
TaskDefault.loadingMessagePrefix=<%=myNLS.getString("webadmin.TaskDefault.loadingMessagePrefix","Loading...") %>
TaskDefault.noHeraldMessage=<%=myNLS.getString("webadmin.TaskDefault.noHeraldMessage","Ready") %>
TaskDefault.FieldHelpMenuItem=<%=myNLS.getString("webadmin.TaskDefault.FieldHelpMenuItem","What is it?") %>
TaskDefault.HelpTopicsMenuItem=<%=myNLS.getString("webadmin.TaskDefault.HelpTopicsMenuItem","How do I?") %>
TaskDefault.IndexMenuItem=<%=myNLS.getString("webadmin.TaskDefault.IndexMenuItem","Property Help") %>
#
helpToolTipString=<%=myNLS.getString("webadmin.helpToolTipString","Help") %>
serverStateRunningToolTipString=<%=myNLS.getString("webadmin.serverStateRunningToolTipString","Server") %>
serverStateStoppedToolTipString=<%=myNLS.getString("webadmin.serverStateStoppedToolTipString","Server") %>
serverStateUnknownToolTipString=<%=myNLS.getString("webadmin.serverStateUnknownToolTipString","Server") %>
messageReadyToolTipString=<%=myNLS.getString("webadmin.messageReadyToolTipString","Ready message") %>
messageInfoToolTipString=Information message
messageWarningToolTipString=Warning message
messageErrorToolTipString=Error message
#
# --------------------------------------- Node View Definition
<%
  int current = 1;
  String currentNode = String.valueOf(current);  
  //System.out.println("webadmin.jsp node definition "+currentNode);
  String nextNode = String.valueOf(current+1);
  Object[] args = {nodeName};
%>
# 1
WASAdmin.TreeElement.<%=currentNode%>=<%=myNLS.getString("webadmin.Introduction.label","Introduction") %>
WASAdmin.TreeElement.<%=currentNode%>.title=<%=myNLS.getString("webadmin.Introduction.title","Introduction to WAS System Management") %>
WASAdmin.TreeElement.<%=currentNode%>.filename=/admin/xmleditor/intro.html
WASAdmin.TreeConnect.<%=currentNode%>.CHILD=0
WASAdmin.TreeConnect.<%=currentNode%>.SIBLING=<%=nextNode%>
WASAdmin.TreeElement.<%=currentNode%>.taskid=WASSAIntro
WASAdmin.TreeElement.<%=currentNode%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/06060003.html
WASAdmin.TreeElement.<%=currentNode%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06060003a.html
WASAdmin.TreeElement.<%=currentNode%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/06060003b.html
<%
  current++;
  currentNode = String.valueOf(current);
  //System.out.println("webadmin.jsp node definition "+currentNode);
  nextNode = String.valueOf(current+1);
%>
# 2 
WASAdmin.TreeElement.<%=currentNode%>=<%=myNLS.getString("webadmin.commit.all.name","Commit All Modifications") %>
WASAdmin.TreeElement.<%=currentNode%>.title=<%=myNLS.getFormattedMessage("webadmin.commit.all.title",args,"Commit All Modifications for {0} to the Repository") %>
WASAdmin.TreeElement.<%=currentNode%>.filename=/admin/xmleditor/commitlist.jsp?taskid=WASSAtopcommit&node=<%=nodeName%>
WASAdmin.TreeConnect.<%=currentNode%>.CHILD=0
WASAdmin.TreeConnect.<%=currentNode%>.SIBLING=<%=nextNode%>
WASAdmin.TreeElement.<%=currentNode%>.SelectedImage=Commit.GIF
WASAdmin.TreeElement.<%=currentNode%>.UnselectedImage=Commit.GIF
WASAdmin.TreeElement.<%=currentNode%>.taskid=WASSAtopcommit
WASAdmin.TreeElement.<%=currentNode%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/0606000305.html
WASAdmin.TreeElement.<%=currentNode%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/060600030501.html
WASAdmin.TreeElement.<%=currentNode%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/060600030502.html
<%
  current++;
  currentNode = String.valueOf(current);
  //System.out.println("webadmin.jsp node definition "+currentNode);
  nextNode = String.valueOf(current+1);
%>
# 3
WASAdmin.TreeElement.<%=currentNode%>=<%=myNLS.getString("webadmin.tasks.name","Tasks") %>
WASAdmin.TreeElement.<%=currentNode%>.title=<%=myNLS.getString("webadmin.tasks.title","List of Tasks supported by this interface") %>
WASAdmin.TreeElement.<%=currentNode%>.filename=/admin/xmleditor/admintasks.html
WASAdmin.TreeConnect.<%=currentNode%>.CHILD=<%=nextNode%>
# Remember to adjust this manually
WASAdmin.TreeConnect.<%=currentNode%>.SIBLING=13
WASAdmin.TreeElement.<%=currentNode%>.SelectedImage=Task.GIF
WASAdmin.TreeElement.<%=currentNode%>.UnselectedImage=Task.GIF
WASAdmin.TreeElement.<%=currentNode%>.taskid=WASSAadmintasks
WASAdmin.TreeElement.<%=currentNode%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/0606000301.html
WASAdmin.TreeElement.<%=currentNode%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/060600030101.html
WASAdmin.TreeElement.<%=currentNode%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/060600030102.html
<%
  current++;
  currentNode = String.valueOf(current);
  //System.out.println("webadmin.jsp node definition "+currentNode);
  nextNode = String.valueOf(current+1);
%>
# 4
WASAdmin.TreeElement.<%=currentNode%>=<%=myNLS.getString("webadmin.create.tasks.name","Create Objects") %>
WASAdmin.TreeElement.<%=currentNode%>.title=<%=myNLS.getString("webadmin.create.tasks.title","Create WAS Configuration Objects ") %>
WASAdmin.TreeElement.<%=currentNode%>.filename=/admin/xmleditor/createtasks.html
WASAdmin.TreeConnect.<%=currentNode%>.CHILD=<%=nextNode%>
# Remember to adjust this manually
WASAdmin.TreeConnect.<%=currentNode%>.SIBLING=12
WASAdmin.TreeElement.<%=currentNode%>.SelectedImage=Create.GIF
WASAdmin.TreeElement.<%=currentNode%>.UnselectedImage=Create.GIF
WASAdmin.TreeElement.<%=currentNode%>.taskid=WASSTDcreatetasks
WASAdmin.TreeElement.<%=currentNode%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/0606000303.html
WASAdmin.TreeElement.<%=currentNode%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/060600030301.html
WASAdmin.TreeElement.<%=currentNode%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/060600030302.html
<%
  current++;
  currentNode = String.valueOf(current);
  //System.out.println("webadmin.jsp node definition "+currentNode);
  nextNode = String.valueOf(current+1);
%>
# 5
WASAdmin.TreeElement.<%=currentNode%>=<%=myNLS.getString("webadmin.create.vhost.name","Create Virtual Host") %>
WASAdmin.TreeElement.<%=currentNode%>.title=<%=myNLS.getString("webadmin.create.vhost.title","Create Virtual Host") %>
WASAdmin.TreeElement.<%=currentNode%>.filename=/admin/xmleditor/host.jsp
WASAdmin.TreeConnect.<%=currentNode%>.CHILD=0
WASAdmin.TreeConnect.<%=currentNode%>.SIBLING=<%=nextNode%>
WASAdmin.TreeElement.<%=currentNode%>.SelectedImage=CreateVirHost.GIF
WASAdmin.TreeElement.<%=currentNode%>.UnselectedImage=CreateVirHost.GIF
WASAdmin.TreeElement.<%=currentNode%>.taskid=WASSTD/host/
WASAdmin.TreeElement.<%=currentNode%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060616.html
WASAdmin.TreeElement.<%=currentNode%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06061603.html
WASAdmin.TreeElement.<%=currentNode%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606160104.html
<%
  current++;
  currentNode = String.valueOf(current);
  //System.out.println("webadmin.jsp node definition "+currentNode);
  nextNode = String.valueOf(current+1);
%>
# 6
WASAdmin.TreeElement.<%=currentNode%>=<%=myNLS.getString("webadmin.create.server.name","Create Server") %>
WASAdmin.TreeElement.<%=currentNode%>.title=<%=myNLS.getString("webadmin.create.server.title","Create WAS Application Server ") %>
WASAdmin.TreeElement.<%=currentNode%>.filename=/admin/xmleditor/server.jsp
WASAdmin.TreeConnect.<%=currentNode%>.CHILD=0
WASAdmin.TreeConnect.<%=currentNode%>.SIBLING=<%=nextNode%>
WASAdmin.TreeElement.<%=currentNode%>.SelectedImage=CreateServer.GIF
WASAdmin.TreeElement.<%=currentNode%>.UnselectedImage=CreateServer.GIF
WASAdmin.TreeElement.<%=currentNode%>.taskid=WASSTD/server/
WASAdmin.TreeElement.<%=currentNode%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060603.html
WASAdmin.TreeElement.<%=currentNode%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06060303.html
WASAdmin.TreeElement.<%=currentNode%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606030104.html
<%
  current++;
  currentNode = String.valueOf(current);
  //System.out.println("webadmin.jsp node definition "+currentNode);
  nextNode = String.valueOf(current+1);
%>
# 7
WASAdmin.TreeElement.<%=currentNode%>=<%=myNLS.getString("webadmin.create.servletengine.name","Create Servlet Engine") %>
WASAdmin.TreeElement.<%=currentNode%>.title=<%=myNLS.getString("webadmin.create.servletengine.title","Create Servlet Engine") %>
WASAdmin.TreeElement.<%=currentNode%>.filename=/admin/xmleditor/servletengine.jsp
WASAdmin.TreeConnect.<%=currentNode%>.CHILD=0
WASAdmin.TreeConnect.<%=currentNode%>.SIBLING=<%=nextNode%>
WASAdmin.TreeElement.<%=currentNode%>.SelectedImage=CreateServletEngine.GIF
WASAdmin.TreeElement.<%=currentNode%>.UnselectedImage=CreateServletEngine.GIF
WASAdmin.TreeElement.<%=currentNode%>.taskid=WASSTD/servletengine/
WASAdmin.TreeElement.<%=currentNode%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060607.html
WASAdmin.TreeElement.<%=currentNode%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06060703.html
WASAdmin.TreeElement.<%=currentNode%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606070104.html
<%
  current++;
  currentNode = String.valueOf(current);
  //System.out.println("webadmin.jsp node definition "+currentNode);
  nextNode = String.valueOf(current+1);
%>
# 8
WASAdmin.TreeElement.<%=currentNode%>=<%=myNLS.getString("webadmin.create.application.name","Create Web Application") %>
WASAdmin.TreeElement.<%=currentNode%>.title=<%=myNLS.getString("webadmin.create.application.title","Create Web Application") %>
WASAdmin.TreeElement.<%=currentNode%>.filename=/admin/xmleditor/webapp.jsp
WASAdmin.TreeConnect.<%=currentNode%>.CHILD=0
WASAdmin.TreeConnect.<%=currentNode%>.SIBLING=<%=nextNode%>
WASAdmin.TreeElement.<%=currentNode%>.SelectedImage=CreateApplication.GIF
WASAdmin.TreeElement.<%=currentNode%>.UnselectedImage=CreateApplication.GIF
WASAdmin.TreeElement.<%=currentNode%>.taskid=WASSTD/webapp/
WASAdmin.TreeElement.<%=currentNode%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060608.html
WASAdmin.TreeElement.<%=currentNode%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06060803.html
WASAdmin.TreeElement.<%=currentNode%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606080104.html
<%
  current++;
  currentNode = String.valueOf(current);
  //System.out.println("webadmin.jsp node definition "+currentNode);
  nextNode = String.valueOf(current+1);
%>
# 9
WASAdmin.TreeElement.<%=currentNode%>=<%=myNLS.getString("webadmin.create.JDBC.driver.name","Create JDBC Driver") %>
WASAdmin.TreeElement.<%=currentNode%>.title=<%=myNLS.getString("webadmin.create.JDBC.driver.title","Create JDBC Driver") %>
WASAdmin.TreeElement.<%=currentNode%>.filename=/admin/xmleditor/jdbcdriver.jsp
WASAdmin.TreeConnect.<%=currentNode%>.CHILD=0
WASAdmin.TreeConnect.<%=currentNode%>.SIBLING=<%=nextNode%>
WASAdmin.TreeElement.<%=currentNode%>.SelectedImage=CreateJDBC.GIF
WASAdmin.TreeElement.<%=currentNode%>.UnselectedImage=CreateJDBC.GIF
WASAdmin.TreeElement.<%=currentNode%>.taskid=WASSTD/jdbcdriver/
WASAdmin.TreeElement.<%=currentNode%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060614.html
WASAdmin.TreeElement.<%=currentNode%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06061403.html
WASAdmin.TreeElement.<%=currentNode%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606140104.html
<%
  current++;
  currentNode = String.valueOf(current);
  //System.out.println("webadmin.jsp node definition "+currentNode);
  nextNode = String.valueOf(current+1);
%>
# 10
WASAdmin.TreeElement.<%=currentNode%>=<%=myNLS.getString("webadmin.create.datasource.name","Create Data Source") %>
WASAdmin.TreeElement.<%=currentNode%>.title=<%=myNLS.getString("webadmin.create.datasource.title","Create Data Source") %>
WASAdmin.TreeElement.<%=currentNode%>.filename=/admin/xmleditor/datasource.jsp
WASAdmin.TreeConnect.<%=currentNode%>.CHILD=0
WASAdmin.TreeConnect.<%=currentNode%>.SIBLING=<%=nextNode%>
WASAdmin.TreeElement.<%=currentNode%>.SelectedImage=CreateDataSrc.gif
WASAdmin.TreeElement.<%=currentNode%>.UnselectedImage=CreateDataSrc.gif
WASAdmin.TreeElement.<%=currentNode%>.taskid=WASSTD/datasource/
WASAdmin.TreeElement.<%=currentNode%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060614.html
WASAdmin.TreeElement.<%=currentNode%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06061403.html
WASAdmin.TreeElement.<%=currentNode%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606140104.html
<%
  current++;
  currentNode = String.valueOf(current);
  //System.out.println("webadmin.jsp node definition "+currentNode);
  nextNode = String.valueOf(current+1);
%>
# 11
WASAdmin.TreeElement.<%=currentNode%>=<%=myNLS.getString("webadmin.create.servlet.name","Create Servlet") %>
WASAdmin.TreeElement.<%=currentNode%>.title=<%=myNLS.getString("webadmin.create.servlet.title","Create Servlet ") %>
WASAdmin.TreeElement.<%=currentNode%>.filename=/admin/xmleditor/servlet.jsp
WASAdmin.TreeConnect.<%=currentNode%>.CHILD=0
WASAdmin.TreeConnect.<%=currentNode%>.SIBLING=0
WASAdmin.TreeElement.<%=currentNode%>.SelectedImage=CreateServlet.GIF
WASAdmin.TreeElement.<%=currentNode%>.UnselectedImage=CreateServlet.GIF
WASAdmin.TreeElement.<%=currentNode%>.taskid=WASSTD/servlet/
WASAdmin.TreeElement.<%=currentNode%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060609.html
WASAdmin.TreeElement.<%=currentNode%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06060903.html
WASAdmin.TreeElement.<%=currentNode%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606090104.html
<%
  current++;
  currentNode = String.valueOf(current);
  //System.out.println("webadmin.jsp node definition "+currentNode);
  nextNode = String.valueOf(current+1);
%>
# 12
WASAdmin.TreeElement.<%=currentNode%>=<%=myNLS.getString("webadmin.xml.export.workspace.name","Export Workspace to XML") %>
WASAdmin.TreeElement.<%=currentNode%>.title=<%=myNLS.getFormattedMessage("webadmin.xml.export.workspace.title",args,"Export Workspace to XML on {0}") %>
WASAdmin.TreeElement.<%=currentNode%>.filename=/admin/xmleditor/xmlexportworkspace.jsp
WASAdmin.TreeConnect.<%=currentNode%>.CHILD=0
WASAdmin.TreeConnect.<%=currentNode%>.SIBLING=0
WASAdmin.TreeElement.<%=currentNode%>.SelectedImage=XML_export.GIF
WASAdmin.TreeElement.<%=currentNode%>.UnselectedImage=XML_export.GIF
WASAdmin.TreeElement.<%=currentNode%>.taskid=WASSTDxmlexportworkspace
WASAdmin.TreeElement.<%=currentNode%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/0606000304.html
WASAdmin.TreeElement.<%=currentNode%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/060600030401.html
WASAdmin.TreeElement.<%=currentNode%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/060600030402.html
<%
  current++;
  currentNode = String.valueOf(current);
  //System.out.println("webadmin.jsp node definition "+currentNode);
  nextNode = String.valueOf(current+1);
%>
# 13
WASAdmin.TreeElement.<%=currentNode%>=<%=myNLS.getString("webadmin.resources.name","Resources") %>
WASAdmin.TreeElement.<%=currentNode%>.title=<%=myNLS.getFormattedMessage("webadmin.resources.title",args,"Resources on {0}") %>
WASAdmin.TreeElement.<%=currentNode%>.filename=/admin/xmleditor/resources.html
WASAdmin.TreeConnect.<%=currentNode%>.CHILD=<%=nextNode%>
WASAdmin.TreeConnect.<%=currentNode%>.SIBLING=0
WASAdmin.TreeElement.<%=currentNode%>.SelectedImage=Information.GIF
WASAdmin.TreeElement.<%=currentNode%>.UnselectedImage=Information.GIF
WASAdmin.TreeElement.<%=currentNode%>.taskid=WASSTD/resources/
WASAdmin.TreeElement.<%=currentNode%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/0606000302.html
WASAdmin.TreeElement.<%=currentNode%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/060600030201.html
WASAdmin.TreeElement.<%=currentNode%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/060600030202.html
<%
   org.w3c.dom.Document resourceTree = (org.w3c.dom.Document)admin.getDocument();
   int numForVisibleElement = 14;  // First n elements are other stuff. 
   java.util.Vector processedElementStack = new Vector();
   boolean visibleElementIsWaitingForVisibleChild = true;
   java.util.Vector visibleElementStack = new Vector();
   java.util.Hashtable visibleElements = new Hashtable();
   java.util.Vector visibleElementAtProcessedLevel = new Vector();
      
   org.w3c.dom.Node currentXMLNode = (org.w3c.dom.Node)resourceTree.getDocumentElement();
   processedElementStack.addElement(currentXMLNode);
   visibleElementStack.addElement(resourceTree);
   visibleElementAtProcessedLevel.addElement(new Integer(0));
   visibleElements.put(resourceTree,Integer.toString(numForVisibleElement-1));
   
   
   java.util.Hashtable visibleTagNames = new Hashtable();
   //visibleTagNames.put("websphere-sa-config","notsupported.html");
   visibleTagNames.put("node","node");
   visibleTagNames.put("virtual-host","host");
   //visibleTagNames.put("uri","notsupported");
   visibleTagNames.put("application-server","server");
   visibleTagNames.put("servlet-engine","servletengine");
   visibleTagNames.put("web-application","webapp");
   visibleTagNames.put("servlet","servlet");
   visibleTagNames.put("jdbc-driver","jdbcdriver");
   visibleTagNames.put("data-source","datasource");
   //visibleTagNames.put("user-profile","userprofile");
   //visibleTagNames.put("session-manager","sessionmanager");
   
   //String variables needed for non-generic resource id
   String serverCurrentName = "";
   String webappCurrentName = "";
   String servletCurrentName = "";
   
   /*************************************/
   /* Loop to traverse n levels of tree */
   /*  each stack entry is a level      */
   /*************************************/
   while (processedElementStack.size()>0) 
   {
if (visibleElementStack.size()>1)
{
}
      /**********************************************/
      /* Each visible element needs to              */ 
      /*  (1) have concept2 tree elements created,  */
      /*  (2) be entered in the visible element     */
      /*      stack so that connections back up the */
      /*      tree can be handled, and              */  
      /*  (3) have their tree element remembered    */
      /*      so that connections down the tree can */
      /*      be handled.                           */  
      /**********************************************/
      if (currentXMLNode.getNodeType() == Node.ELEMENT_NODE) 
      { // supported node type
         String action = ((Element)currentXMLNode).getAttribute("action");
         if ((visibleTagNames.get(((Element)currentXMLNode).getTagName()) != null) && 
          (action != null) && 
          (action.length() > 0))
         { // supported tag (it is in the list and has an action attribute)
     
            /*********************************************/
            /* the concept2 properties for a navigation  */
            /*  tree element follow,                     */
            /* each element is given a                   */
            /*  null set of pointers to children and     */
            /*  siblings which will be overridden later  */
            /*  if more (visible) family is discovered.  */
            /*********************************************/
            String currentC2Node = Integer.toString(numForVisibleElement);
            String tagName = ((Element)currentXMLNode).getTagName();
            String elementName = ((Element)currentXMLNode).getAttribute("name");
            if ((elementName == null) || (elementName.length()==0))
            {
               elementName = myNLS.getString("webadmin."+tagName+".label" , tagName);
            }
       
            visibleElements.put(currentXMLNode,currentC2Node);
            if (visibleElementIsWaitingForVisibleChild) 
            {
%>WASAdmin.TreeConnect.<%=visibleElements.get(visibleElementStack.lastElement())%>.CHILD=<%=currentC2Node%>
<%
               visibleElementStack.addElement(currentXMLNode);
               visibleElementAtProcessedLevel.addElement(new Integer(processedElementStack.size()-1));
               visibleElementIsWaitingForVisibleChild = false;
            }
            else
            {
%>WASAdmin.TreeConnect.<%=visibleElements.get(visibleElementStack.lastElement())%>.SIBLING=<%=currentC2Node%>
<%
               visibleElementStack.setElementAt(currentXMLNode,visibleElementStack.size()-1);
            }
       
            if (tagName.equals("node"))
            {
%>WASAdmin.TreeElement.<%=currentC2Node%>.filename=/admin/xmleditor/node.jsp?name=<%=elementName%> 
WASAdmin.TreeElement.<%=currentC2Node%>.SelectedImage=unknown.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.UnselectedImage=unknown.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.taskid=WASSTD/node/<%=java.net.URLEncoder.encode(elementName)%> 
WASAdmin.TreeElement.<%=currentC2Node%>.title=<%=elementName %> <%=myNLS.getString("webadmin.node.label","(node)")%>
WASAdmin.TreeElement.<%=currentC2Node%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060602.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06060203.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606020104.html
<%       
            }
            else
            {
               if (tagName.equals("application-server"))
               {
                  // needed for non-generic resource id below server
                  serverCurrentName = elementName;
%>WASAdmin.TreeElement.<%=currentC2Node%>.filename=/admin/xmleditor/server.jsp?server=<%=serverCurrentName %> 
WASAdmin.TreeElement.<%=currentC2Node%>.SelectedImage=Server.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.UnselectedImage=Server.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.taskid=WASSTD/server/<%=java.net.URLEncoder.encode(serverCurrentName)%> 
WASAdmin.TreeElement.<%=currentC2Node%>.title=<%=elementName %> <%=myNLS.getString("webadmin.application-server.label","(application-server)")%>
WASAdmin.TreeElement.<%=currentC2Node%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060603.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06060303.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606030104.html
<%         
               }
               else
               { 
                  if (tagName.equals("servlet-engine"))
                  {
%>WASAdmin.TreeElement.<%=currentC2Node%>.filename=/admin/xmleditor/servletengine.jsp?server=<%=serverCurrentName %>&name=<%=elementName%> 
WASAdmin.TreeElement.<%=currentC2Node%>.SelectedImage=servletcollection.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.UnselectedImage=servletcollection.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.taskid=WASSTD/servletengine/<%=java.net.URLEncoder.encode(elementName) %> 
WASAdmin.TreeElement.<%=currentC2Node%>.title=<%=elementName %> <%=myNLS.getString("webadmin.servlet-engine.label","(servlet-engine)")%>
WASAdmin.TreeElement.<%=currentC2Node%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060607.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06060703.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606070104.html
<%           
                  }
                  else
                  {
                     if (tagName.equals("web-application"))
                     {
                        // needed for non-generic resource id below server
                        webappCurrentName = elementName;
%>WASAdmin.TreeElement.<%=currentC2Node%>.filename=/admin/xmleditor/webapp.jsp?server=<%=serverCurrentName%>&name=<%=webappCurrentName%> 
WASAdmin.TreeElement.<%=currentC2Node%>.SelectedImage=Application.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.UnselectedImage=Application.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.taskid=WASSTD/webapp/<%=java.net.URLEncoder.encode(webappCurrentName) %> 
WASAdmin.TreeElement.<%=currentC2Node%>.title=<%=elementName %> <%=myNLS.getString("webadmin.web-application.label","(web-application)")%>
WASAdmin.TreeElement.<%=currentC2Node%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060608.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06060803.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606080104.html
<%
                     }
                     else
                     {
                        if (tagName.equals("servlet"))
                        {
                           servletCurrentName = elementName;
%>WASAdmin.TreeElement.<%=currentC2Node%>.filename=/admin/xmleditor/servlet.jsp?server=<%=serverCurrentName %>&application=<%=webappCurrentName %>&name=<%=servletCurrentName %> 
WASAdmin.TreeElement.<%=currentC2Node%>.SelectedImage=Servlet.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.UnselectedImage=Servlet.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.taskid=WASSTD/servlet/<%=java.net.URLEncoder.encode(servletCurrentName) %> 
WASAdmin.TreeElement.<%=currentC2Node%>.title=<%=elementName %> <%=myNLS.getString("webadmin.servlet.label","(servlet)")%>
WASAdmin.TreeElement.<%=currentC2Node%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/0606000302.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/060600030201.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/060600030202.html
<%               
                        }
                        else
                        {
                           if (tagName.equals("virtual-host"))
                           {
%>WASAdmin.TreeElement.<%=currentC2Node%>.filename=/admin/xmleditor/host.jsp?name=<%=elementName %> 
WASAdmin.TreeElement.<%=currentC2Node%>.SelectedImage=VirtualHost.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.UnselectedImage=VirtualHost.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.taskid=WASSTD/host/<%=java.net.URLEncoder.encode(elementName) %> 
WASAdmin.TreeElement.<%=currentC2Node%>.title=<%=elementName %> <%=myNLS.getString("webadmin.virtual-host.label","(virtual-host)")%>
WASAdmin.TreeElement.<%=currentC2Node%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060616.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06061603.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606160104.html
<%
                           }
                           else
                           {
                              if (tagName.equals("jdbc-driver"))
                              {
 %>WASAdmin.TreeElement.<%=currentC2Node%>.filename=/admin/xmleditor/jdbcdriver.jsp?jdbcdriver=<%=elementName %> 
WASAdmin.TreeElement.<%=currentC2Node%>.SelectedImage=JDBC.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.UnselectedImage=JDBC.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.taskid=WASSTD/jdbcdriver/<%=java.net.URLEncoder.encode(elementName) %> 
WASAdmin.TreeElement.<%=currentC2Node%>.title=<%=elementName %> <%=myNLS.getString("webadmin.jdbc-driver.label","(jdbc-driver)")%>
WASAdmin.TreeElement.<%=currentC2Node%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060614.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06061403.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606140104.html
<%
                              }
                              else
                              {
                                 if (tagName.equals("data-source"))
                                 {
 %>WASAdmin.TreeElement.<%=currentC2Node%>.filename=/admin/xmleditor/datasource.jsp?datasource=<%=elementName %> 
WASAdmin.TreeElement.<%=currentC2Node%>.SelectedImage=DataSource.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.UnselectedImage=DataSource.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.taskid=WASSTD/datasource/<%=java.net.URLEncoder.encode(elementName) %> 
WASAdmin.TreeElement.<%=currentC2Node%>.title=<%=elementName %> <%=myNLS.getString("webadmin.datasource.label","(datasource)")%>
WASAdmin.TreeElement.<%=currentC2Node%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/060614.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06061403.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/0606140104.html
<%
                                 }
                                 else
                                 {
%>WASAdmin.TreeElement.<%=currentC2Node%>.filename=/admin/xmleditor/<%=visibleTagNames.get(tagName)%>.jsp?name=<%=elementName %> 
WASAdmin.TreeElement.<%=currentC2Node%>.SelectedImage=<%=visibleTagNames.get(tagName)%>.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.UnselectedImage=<%=visibleTagNames.get(tagName)%>.GIF
WASAdmin.TreeElement.<%=currentC2Node%>.taskid=WASSTD/<%=visibleTagNames.get(tagName)%>/<%=java.net.URLEncoder.encode(elementName) %> 
WASAdmin.TreeElement.<%=currentC2Node%>.title=<%=elementName %> <%=myNLS.getString("webadmin.unknown-resource-type.label","(unknown resource type)")%>
WASAdmin.TreeElement.<%=currentC2Node%>.FieldHelpUrl=/IBMWebAS/InfoCenter/was/06060003.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpTopicsUrl=/IBMWebAS/InfoCenter/was/06060003a.html
WASAdmin.TreeElement.<%=currentC2Node%>.HelpIndexUrl=/IBMWebAS/InfoCenter/was/06060003b.html
<%
                                 }
                              }
                           }
                        }
                     }
                  }
               }
            }
%>WASAdmin.TreeElement.<%=currentC2Node%>=<%=elementName%>
WASAdmin.TreeConnect.<%=currentC2Node%>.CHILD=0
WASAdmin.TreeConnect.<%=currentC2Node%>.SIBLING=0
<%
            //System.out.println("webadmin.jsp node definition "+currentC2Node);
            numForVisibleElement++; // each concept2 tree element needs an integer
         } // end of supported tag and action attribute)
      } // end of supported node type
     
      /**********************************************/
      /* Process the current element to navigate    */ 
      /*  to its first child if it has one,         */
      /*  to its next sibling if it has no child,   */
      /*  to its parents (or greater ancestors)     */
      /*      next sibling.                         */
      /* If the element being navigated to is       */
      /*  visible, handle connections between       */
      /*  concept2 tree elements.                   */  
      /**********************************************/
      Node firstChild = currentXMLNode.getFirstChild();

      if (firstChild != null) 
      { // currentXMLNode has descendants
         if (currentXMLNode == visibleElementStack.lastElement())
         { // currentXMLNode is visible (always the most recent stack entry if visible)
            /***********************************************/
            /* mark it as waiting for a visible descendant */
            /***********************************************/ 
            visibleElementIsWaitingForVisibleChild = true;
         }
       
         /******************/
         /* navigate to it */
         /******************/
         processedElementStack.addElement(firstChild);
         currentXMLNode = firstChild;
      }
      else 
      { // currentXMLNode has no offspring, its a leaf
     
         Node nextSibling = currentXMLNode.getNextSibling();
         if ( nextSibling != null ) 
         {
            if (currentXMLNode == visibleElementStack.lastElement())
            { // a leaf can have no children
               //*****************************************/
               //* The visible element missed its chance */
               //*  to have a visible child node.        */
               //*****************************************/
               visibleElementIsWaitingForVisibleChild = false;
            }
            /******************/
            /* navigate to it */
            /******************/                    
            processedElementStack.setElementAt(nextSibling,processedElementStack.size()-1);
            currentXMLNode = nextSibling;
         } 
         else 
         { // currentXMLNode has no offspring or siblings, level is complete
            /*************************************/
            /* The auntNode represents a sibling */
            /*  of an ancestor, and is how we    */
            /*  move to another branch of the    */
            /*  family after exploring a subtree.*/
            /* We move back up through our       */
            /*  ancestors until we find one with */
            /*  a nextSibling, or we empty the   */
            /*  stack of generations.            */
            /*************************************/
            Node auntNode = null;
         
            while ((auntNode == null) && (processedElementStack.size() > 0))
            {
               if (((Integer)(visibleElementAtProcessedLevel.lastElement())).intValue() >= (processedElementStack.size()-1))
               { // visible level is complete too
                  visibleElementStack.removeElement(visibleElementStack.lastElement());
                  visibleElementAtProcessedLevel.removeElement(visibleElementAtProcessedLevel.lastElement());
                  /**************************************/
                  /* The visible element just removed   */
                  /*  missed its chance to have a       */
                  /*  visible child node.               */
                  /**************************************/
                  visibleElementIsWaitingForVisibleChild = false;
               }
               /******************************/
               /* navigate back up the stack */
               /******************************/
               processedElementStack.removeElement(currentXMLNode);
               if (processedElementStack.size() > 0) 
               {
                  currentXMLNode = (Node)processedElementStack.lastElement();
                  auntNode = currentXMLNode.getNextSibling();
               
               }
               else
               {
                  currentXMLNode = null;
                  auntNode = null;
               }
            }

            /*****************************************/
            /* When navigating back up the hierarchy,*/
            /*  we don't want to visit these nodes   */
            /*  children again, so we go ahead and   */
            /*  move to their sibling if they have   */
            /*  one.                                 */
            /*****************************************/         
            if (auntNode != null)
            { // backed up to a level with another sibling
         
               if (currentXMLNode == visibleElementStack.lastElement())
               { // either visible children are already in rolls or no visible children
                  /*****************************************/
                  /* The visible element missed its chance */
                  /*  to have a visible child node.        */
                  /*****************************************/
                  visibleElementIsWaitingForVisibleChild = false;
              
               }
               /***************************/
               /* navigate to the sibling */
               /***************************/
               processedElementStack.setElementAt(auntNode,processedElementStack.size()-1);
               currentXMLNode = (Element)processedElementStack.lastElement();
            }
         }
      }
   }

%>
# --------------------------------------------------
# ConceptTwo.style
#
# This file contains commands that define the look and
# feel for the Web UI components, e.g., navigation area
# and action center.
#
# --------------------------------------------------
@version=00001
#

DrawerDefault.DrawerForegroundColor=255,255,255
DrawerDefault.DrawerFont=Dialog,BOLD,12
DrawerDefault.FlyOver=0

DrawerDefault.DrawerDrawOn=0
DrawerDefault.DrawerTabOn=0

DrawerDefault.DrawerOpenImage=o_drawer_north.gif
DrawerDefault.DrawerOpenImageEast=o_drawer_top_east.gif
DrawerDefault.DrawerOpenImageWest=o_drawer_top_west.gif
DrawerDefault.DrawerClosedImage=c_drawer_north.gif
DrawerDefault.DrawerClosedImageEast=c_drawer_east.gif
DrawerDefault.DrawerClosedImageWest=c_drawer_west.gif
DrawerDefault.DrawerContentsImageSouth=o_drawer_middle_south.gif
DrawerDefault.DrawerContentsImageSouthEast=o_drawer_bottom_east.gif
DrawerDefault.DrawerContentsImageSouthWest=o_drawer_bottom_west.gif

DrawerDefault.DrawerOpenContentsBackgroundColor=255,255,255

TaskDefault.Font=Dialog,PLAIN,12
TaskDefault.FontSelected=Dialog,BOLD,12

TaskDefault.TextForegroundColor=0,0,0
TaskDefault.TextBackgroundColor=255,255,255
TaskDefault.TextHoverForegroundColor=0,0,0
TaskDefault.TextHoverBackgroundColor=255,255,255
TaskDefault.TextSelectedForegroundColor=0,0,0
TaskDefault.TextSelectedBackgroundColor=255,255,255

TaskDefault.IndicatorForegroundColor=0,0,0
TaskDefault.IndicatorBackgroundColor=255,255,255
TaskDefault.IndicatorOutline=255,255,255

TaskDefault.IndicatorHoverForegroundColor=0,0,0
TaskDefault.IndicatorHoverBackgroundColor=255,255,255
TaskDefault.IndicatorHoverOutline=255,255,255

TaskDefault.IndicatorSelectedForegroundColor=0,0,0
TaskDefault.IndicatorSelectedBackgroundColor=255,255,255
TaskDefault.IndicatorSelectedOutline=255,255,255

TaskDefault.SelectedImage=task.gif
TaskDefault.UnselectedImage=task.gif

TaskDefault.FlyOver=0
TaskDefault.GroupNavigator=1

# --------------------------------------------------

hoverBackgroundColor=255,255,153
messageFont=Dialog,PLAIN,12
messageHoverFont=Dialog,PLAIN,12
subtitleTextColor=255,255,255
subtitleFont=Dialog,PLAIN,12
subtitleHoverFont=Dialog,PLAIN,12
titleTextColor=255,255,255
titleFont=Dialog,PLAIN,18
titleHoverFont=Dialog,PLAIN,12
menuFont=Dialog,PLAIN,12
toolTipFont=Dialog,PLAIN,12

# --------------------------------------------------

workAreaFont=Dialog,PLAIN,12
workAreaTextColor=0,0,0
workAreaBackgroundColor=255,255,255

# --------------------------------------------------


# message severity <0..3: ready, info, warning, error>
# loading task message
TaskDefault.loadingMessageSeverity=0

# no herald found message
TaskDefault.noHeraldSeverity=3
TaskDefault.noHeraldMessage=Communications Error

# Looking for herald timeout value (in seconds)
noHeraldTimer=90

# Hover windows enable/disable
titleHover=true
subtitleHover=true
messageHover=true
# Hover delay time (seconds): if hover enabled and hoverTimer > 0, use timer for hover
hoverTime=1

# --------------------------------------------------

Help.ManagedLaunch=Yes
Help.WindowAtts=toolbar=yes,menubar=no,status=no,resizable=yes
#Help.Left=
Help.Top=0
Help.Width=600
Help.Height=400

# --------------------------------------------------

DeskDrawBorder=0

ControlCenterImage=acenter_center.gif
ControlCenterImageEast=acenter_east.gif
ControlCenterImageWest=acenter_west.gif
ControlCenterDrawBackground=0

titleOffsetX=8
titleOffsetY=9
subtitleOffsetX=8
subtitleOffsetY=37
megaphoneImageX=2
megaphoneImageY=62
buttonOffsetX=0
buttonOffsetY=10


<%
}
else
{
  System.out.println("webadmin.jsp Init in progress at this time, delay java client.");
  /*********************************************/
  /* the init of the objects needed to build   */
  /* application mapfile has not yet finished  */
  /* wait for a decent interval to keep the    */
  /* java client from pegging the clients CPU, */
  /* then return a mapfile that will cause the */
  /* java client to make another try.          */
  /*********************************************/ 
  try {
         Thread.currentThread().sleep(4400);
  } catch (InterruptedException ie) {}
  String initState = java.net.URLEncoder.encode(initResult);
  System.out.println("webadmin.jsp "+Integer.toString(Thread.currentThread().hashCode())+":"+" initState "+initState);
%>
# initialization of application is still in progress
# try to include the results of it completing
@include=webadmin.jsp?initState=<%=initState%>
#
<%
}
%>

# server name; used as prefix for drawer commands
Server.1=WASAdmin
WASAdmin.DrawerOpen=True
WASAdmin.Tree=WASAdmin

# ==================================================
# WASAdmin GALLERY
# ================================================== 

# --------------------------------------------- Help
#TaskDefault.FieldHelpUrl=help/2frs1fld.html
#TaskDefault.HelpTopicsUrl=help/2frs1td.html
#TaskDefault.HelpIndexUrl=help/2tabindex.html
# -------------------------------------- End of help



