#
# Procedure for printing the attributes for any objects specified
# or for all objects if no objects are specified
# The script init.tcl must be loaded prior to using this procedure
#

proc printAttributes {{options all} {objects all} args} {
    global OBJECTS
    if {[string first "-" $options] != 0} {
	set objects $options
	set options ""
    }
    if {[string compare $objects "all"] == 0} {set objects $OBJECTS}
    if {$args != ""} {lappend objects $args}
    foreach o $objects { 
	set cmd [concat $o attributes $options]
	puts "# $cmd"
	set result [eval $cmd]
	puts $result
	
    }
}
