@echo off
setlocal
call setupCmdLine.bat
set WAR-FILENAME=%1
set WEBAPP-DEST=%2
set VHOST-NAME=%3
set WEBAPP-PATH=%4
set WEBAPP-NAME=%5

if "%WAR-FILENAME%"=="" goto error
if "%WEBAPP-DEST%"=="" goto error
if "%VHOST-NAME%"=="" goto error
if "%WEBAPP-PATH%"=="" goto error
if "%WEBAPP-NAME%"=="" goto error

%JAVA_HOME%\bin\java -classpath %WAS_HOME%\lib\ant.jar;%WAS_HOME%\lib\ibmant.jar;%WAS_HOME%\lib\antxalan_1_1.jar;%WAS_HOME%\lib\xerces.jar org.apache.tools.ant.Main -Dwar.filename=%WAR-FILENAME% -buildfile %WAS_HOME%\properties\convertwar.xml -Dwebapp.dest=%WEBAPP-DEST% -Dvirtual.host.name=%VHOST-NAME% -Dwas.home=%WAS_HOME% -Droot.uri=%WEBAPP-PATH% -Dwebapp.name=%WEBAPP-NAME% -Dant.home=%WAS_HOME% -Dwas.java.name=%JAVA_HOME%\bin\java transform.to.webapp
goto exit

:error
echo wartowebapp syntax :
echo wartowebapp [war filename] [webapp destination] [virtual host name] [webapp path] [webapp name]
echo 	e.g
echo 	wartowebapp webapplication.war \websphere\appserver\hosts\default_host default_host /path WebAppName

:exit
endlocal
