@echo off
echo OFF
set COPYCMD=/Y
set F_JDK_HOME=jdk
:check_java_home
if exist %F_JDK_HOME%\bin\java.exe  goto uninstall

:prompt_java_home
GetInput F_JDK_HOME "Enter the directory where the IBM JDK 1.2.2 is installed: " ~jdkhome.bat
call ~jdkhome.bat
del ~jdkhome.bat
goto check_java_home


:uninstall
GetInput F_CONFIRM "Uninstall IBM WebSphere Application Server PTF6 (Yes/No)? " ~confirm.bat
call ~confirm.bat
del ~confirm.bat
if (%F_CONFIRM%) == (y) goto wasptf
if (%F_CONFIRM%) == (Y) goto wasptf
if (%F_CONFIRM%) == (yes) goto wasptf
if (%F_CONFIRM%) == (Yes) goto wasptf
if (%F_CONFIRM%) == (YES) goto wasptf
goto prompt_ihs

:wasptf
echo off
echo "Uninstalling the WebSphere Application Server 3.5 PTF 6"
%F_JDK_HOME%\bin\java -jar was35_ptf_6_backup.jar -log logs/was35_ptf_6.log
if (%errorlevel%) NEQ (0) goto was_ptf_error

:prompt_ihs
GetInput F_CONFIRM "Uninstall IBM HTTP Server 1.3.12.6 PTF (Yes/No)? " ~confirm.bat
call ~confirm.bat
del ~confirm.bat
if (%F_CONFIRM%) == (y) goto ihsptf
if (%F_CONFIRM%) == (Y) goto ihsptf
if (%F_CONFIRM%) == (yes) goto ihsptf
if (%F_CONFIRM%) == (Yes) goto ihsptf
if (%F_CONFIRM%) == (YES) goto ihsptf
goto jdk_prompt

:ihsptf
echo off
echo "Uninstalling the IBM HTTP Server 1.3.12.6 PTF"
%F_JDK_HOME%\bin\java -jar ihs_ptf_6_backup.jar -log logs/ihs_ptf_6.log
if (%errorlevel%) NEQ (0) goto ihs_ptf_error

:jdk_prompt
GetInput F_CONFIRM "Uninstall IBM JDK PTF (Yes/No)? " ~confirm.bat
call ~confirm.bat
del ~confirm.bat
if (%F_CONFIRM%) == (y) goto jdkptf
if (%F_CONFIRM%) == (Y) goto jdkptf
if (%F_CONFIRM%) == (yes) goto jdkptf
if (%F_CONFIRM%) == (Yes) goto jdkptf
if (%F_CONFIRM%) == (YES) goto jdkptf
goto done

:jdkptf
echo off
echo "Uninstalling the IBM JDK 1.2.2 PTF"
md java_ptf_6
%F_JDK_HOME%\bin\java -jar jdk_ptf_6_backup.jar -log logs/jdk_ptf_6.log
if (%errorlevel%) NEQ (0) goto jdk_ptf_error
pause
xcopy java_ptf_6\* %F_JDK_HOME% /s/e/q
rmdir java_ptf_6 /S/Q

goto done
:was_ptf_error
echo "The WebSphere PTF uninstall has encountered an error, "
echo "or the user has chosen to end the program. "
goto done

:ihs_ptf_error
echo "The IBM HTTP Server PTF uninstall has encountered an error, "
echo "or the user has chosen to end the program. "
goto done

:jdk_ptf_error
echo "The JDK PTF uninstall has encountered an error, "
echo "or the user has chosen to end the program."

:done

:exit
